Index: uspace/app/sbi/src/builtin.c
===================================================================
--- uspace/app/sbi/src/builtin.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/builtin.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -42,5 +42,7 @@
 #include "builtin/bi_boxed.h"
 #include "builtin/bi_error.h"
+#include "builtin/bi_char.h"
 #include "builtin/bi_fun.h"
+#include "builtin/bi_int.h"
 #include "builtin/bi_textfile.h"
 #include "builtin/bi_string.h"
@@ -52,4 +54,5 @@
 #include "os/os.h"
 #include "parse.h"
+#include "rdata.h"
 #include "run.h"
 #include "stree.h"
@@ -89,5 +92,7 @@
 
 	bi_error_declare(bi);
+	bi_char_declare(bi);
 	bi_fun_declare(bi);
+	bi_int_declare(bi);
 	bi_textfile_declare(bi);
 	bi_string_declare(bi);
@@ -105,5 +110,7 @@
 	bi_boxed_bind(bi);
 	bi_error_bind(bi);
+	bi_char_bind(bi);
 	bi_fun_bind(bi);
+	bi_int_bind(bi);
 	bi_textfile_bind(bi);
 	bi_string_bind(bi);
@@ -250,5 +257,4 @@
 {
 	stree_symbol_t *fun_sym;
-	builtin_t *bi;
 	builtin_proc_t bproc;
 
@@ -257,5 +263,4 @@
 #endif
 	fun_sym = proc->outer_symbol;
-	bi = run->program->builtin;
 
 	bproc = proc->bi_handler;
@@ -298,5 +303,40 @@
 }
 
-/** Declare a builtin function in @a csi.
+/** Return string value from builtin procedure.
+ *
+ * Makes it easy for a builtin procedure to return value of type @c string.
+ *
+ * @param run		Runner object
+ * @param str		String value. Must be allocated from heap and its
+ *			ownership is hereby given up.
+ */
+void builtin_return_string(run_t *run, const char *astr)
+{
+	rdata_string_t *rstring;
+	rdata_var_t *rvar;
+	rdata_value_t *rval;
+	rdata_item_t *ritem;
+
+	run_proc_ar_t *proc_ar;
+
+#ifdef DEBUG_RUN_TRACE
+	printf("Return string '%s' from builtin function.\n", astr);
+#endif
+	rstring = rdata_string_new();
+	rstring->value = astr;
+
+	rvar = rdata_var_new(vc_string);
+	rvar->u.string_v = rstring;
+	rval = rdata_value_new();
+	rval->var = rvar;
+
+	ritem = rdata_item_new(ic_value);
+	ritem->u.value = rval;
+
+	proc_ar = run_get_current_proc_ar(run);
+	proc_ar->retval = ritem;
+}
+
+/** Declare a static builtin function in @a csi.
  *
  * Declare a builtin function member of CSI @a csi. Deprecated in favor
@@ -314,4 +354,5 @@
 	stree_csimbr_t *csimbr;
 	stree_symbol_t *fun_sym;
+	stree_symbol_attr_t *sym_attr;
 
 	ident = stree_ident_new();
@@ -333,4 +374,8 @@
 	fun_sym->u.fun = fun;
 	fun_sym->outer_csi = csi;
+
+	sym_attr = stree_symbol_attr_new(sac_static);
+	list_append(&fun_sym->attr, sym_attr);
+
 	fun->symbol = fun_sym;
 	fun->proc->outer_symbol = fun_sym;
Index: uspace/app/sbi/src/builtin.h
===================================================================
--- uspace/app/sbi/src/builtin.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/builtin.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -40,4 +40,5 @@
 
 rdata_var_t *builtin_get_self_mbr_var(run_t *run, const char *mbr_name);
+void builtin_return_string(run_t *run, const char *str);
 
 stree_symbol_t *builtin_declare_fun(stree_csi_t *csi, const char *name);
Index: uspace/app/sbi/src/builtin/bi_char.c
===================================================================
--- uspace/app/sbi/src/builtin/bi_char.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/app/sbi/src/builtin/bi_char.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,96 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file Char builtin binding. */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <assert.h>
+#include "../bigint.h"
+#include "../builtin.h"
+#include "../debug.h"
+#include "../mytypes.h"
+#include "../os/os.h"
+#include "../rdata.h"
+#include "../run.h"
+#include "../strtab.h"
+
+#include "bi_char.h"
+
+static void bi_char_get_as_string(run_t *run);
+
+/** Declare Char builtin.
+ *
+ * @param bi	Builtin object
+ */
+void bi_char_declare(builtin_t *bi)
+{
+	(void) bi;
+}
+
+/** Bind Char builtin.
+ *
+ * @param bi	Builtin object
+ */
+void bi_char_bind(builtin_t *bi)
+{
+	builtin_fun_bind(bi, "Char", "get_as_string", bi_char_get_as_string);
+}
+
+/** Return string representation.
+ *
+ * @param run	Runner object
+ */
+static void bi_char_get_as_string(run_t *run)
+{
+        rdata_var_t *self_value_var;
+        bigint_t *cval;
+        char *str;
+        int char_val;
+        int rc;
+
+#ifdef DEBUG_RUN_TRACE
+	printf("Convert char to string.\n");
+#endif
+	/* Extract self.Value */
+	self_value_var = builtin_get_self_mbr_var(run, "Value");
+	assert(self_value_var->vc == vc_char);
+	cval = &self_value_var->u.char_v->value;
+
+	rc = bigint_get_value_int(cval, &char_val);
+	if (rc != EOK) {
+		/* XXX Should raise exception. */
+		builtin_return_string(run, os_str_dup("?"));
+		return;
+	}
+
+	str = os_chr_to_astr((wchar_t) char_val);
+
+	/* Ownership of str is transferred. */
+	builtin_return_string(run, str);
+}
Index: uspace/app/sbi/src/builtin/bi_char.h
===================================================================
--- uspace/app/sbi/src/builtin/bi_char.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/app/sbi/src/builtin/bi_char.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,37 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef BI_CHAR_H_
+#define BI_CHAR_H_
+
+#include "../mytypes.h"
+
+void bi_char_declare(builtin_t *bi);
+void bi_char_bind(builtin_t *bi);
+
+#endif
Index: uspace/app/sbi/src/builtin/bi_fun.c
===================================================================
--- uspace/app/sbi/src/builtin/bi_fun.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/builtin/bi_fun.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -94,5 +94,5 @@
 	builtin_code_snippet(bi,
 		"class Task is\n"
-			"fun Exec(args : string[], packed), builtin;\n"
+			"fun Exec(args : string[], packed), static, builtin;\n"
 		"end\n");
 }
Index: uspace/app/sbi/src/builtin/bi_int.c
===================================================================
--- uspace/app/sbi/src/builtin/bi_int.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/app/sbi/src/builtin/bi_int.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,87 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file Int builtin binding. */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <assert.h>
+#include "../bigint.h"
+#include "../builtin.h"
+#include "../debug.h"
+#include "../mytypes.h"
+#include "../os/os.h"
+#include "../rdata.h"
+#include "../run.h"
+#include "../strtab.h"
+
+#include "bi_int.h"
+
+static void bi_int_get_as_string(run_t *run);
+
+/** Declare Int builtin.
+ *
+ * @param bi	Builtin object
+ */
+void bi_int_declare(builtin_t *bi)
+{
+	(void) bi;
+}
+
+/** Bind Int builtin.
+ *
+ * @param bi	Builtin object
+ */
+void bi_int_bind(builtin_t *bi)
+{
+	builtin_fun_bind(bi, "Int", "get_as_string", bi_int_get_as_string);
+}
+
+/** Return string representation.
+ *
+ * @param run	Runner object
+ */
+static void bi_int_get_as_string(run_t *run)
+{
+        rdata_var_t *self_value_var;
+        bigint_t *ival;
+        char *str;
+
+	/* Extract self.Value */
+	self_value_var = builtin_get_self_mbr_var(run, "Value");
+	assert(self_value_var->vc == vc_int);
+	ival = &self_value_var->u.int_v->value;
+
+	bigint_get_as_string(ival, &str);
+
+#ifdef DEBUG_RUN_TRACE
+	printf("Convert int to string '%s'.\n", str);
+#endif
+	/* Ownership of str is transferred. */
+	builtin_return_string(run, str);
+}
Index: uspace/app/sbi/src/builtin/bi_int.h
===================================================================
--- uspace/app/sbi/src/builtin/bi_int.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/app/sbi/src/builtin/bi_int.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,37 @@
+/*
+ * Copyright (c) 2010 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef BI_INT_H_
+#define BI_INT_H_
+
+#include "../mytypes.h"
+
+void bi_int_declare(builtin_t *bi);
+void bi_int_bind(builtin_t *bi);
+
+#endif
Index: uspace/app/sbi/src/builtin/bi_string.c
===================================================================
--- uspace/app/sbi/src/builtin/bi_string.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/builtin/bi_string.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -116,4 +116,5 @@
         rdata_var_t *self_value_var;
         const char *str;
+        const char *slice;
         size_t str_l;
 
@@ -125,11 +126,4 @@
 
 	int rc;
-
-	rdata_string_t *rstring;
-	rdata_var_t *rvar;
-	rdata_value_t *rval;
-	rdata_item_t *ritem;
-
-	run_proc_ar_t *proc_ar;
 
 	/* Extract self.Value */
@@ -165,17 +159,7 @@
 	    start, length, str);
 #endif
-	/* Construct return value. */
-	rstring = rdata_string_new();
-	rstring->value = os_str_aslice(str, start, length);
+	slice = os_str_aslice(str, start, length);
 
-	rvar = rdata_var_new(vc_string);
-	rvar->u.string_v = rstring;
-	rval = rdata_value_new();
-	rval->var = rvar;
-
-	ritem = rdata_item_new(ic_value);
-	ritem->u.value = rval;
-
-	proc_ar = run_get_current_proc_ar(run);
-	proc_ar->retval = ritem;
+	/* Ownership of slice is transferred. */
+	builtin_return_string(run, slice);
 }
Index: uspace/app/sbi/src/imode.c
===================================================================
--- uspace/app/sbi/src/imode.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/imode.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -130,7 +130,9 @@
 
 	/* Construct run context. */
+	run_gdata_init(&run);
+
 	run.thread_ar = run_thread_ar_new();
 	list_init(&run.thread_ar->proc_ar);
-	run_proc_ar_create(&run, NULL, proc, &proc_ar);
+	run_proc_ar_create(&run, run.gdata, proc, &proc_ar);
 	list_append(&run.thread_ar->proc_ar, proc_ar);
 
Index: uspace/app/sbi/src/input.c
===================================================================
--- uspace/app/sbi/src/input.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/input.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -206,5 +206,5 @@
 			*dp++ = *sp++;
 
-		*dp++ = '\0';
+		*dp = '\0';
 		input->str = sp;
 		*line = input->buffer;
Index: uspace/app/sbi/src/mytypes.h
===================================================================
--- uspace/app/sbi/src/mytypes.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/mytypes.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -43,4 +43,10 @@
 } walk_state_t;
 
+/** Static vs. nonstatic */
+typedef enum {
+	sn_nonstatic,
+	sn_static
+} statns_t;
+
 /** Error return codes. */
 #include <errno.h>
Index: uspace/app/sbi/src/os/helenos.c
===================================================================
--- uspace/app/sbi/src/os/helenos.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/os/helenos.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -173,4 +173,31 @@
 }
 
+/** Convert character to new string.
+ *
+ * @param chr		Character
+ * @return		Newly allocated string.
+ */
+char *os_chr_to_astr(wchar_t chr)
+{
+	char *str;
+	size_t offset;
+
+	str = malloc(STR_BOUNDS(1) + 1);
+	if (str == NULL) {
+		printf("Memory allocation error.\n");
+		exit(1);
+	}
+
+	offset = 0;
+	if (chr_encode(chr, str, &offset, STR_BOUNDS(1)) != EOK) {
+		/* XXX Should handle gracefully */
+		printf("String conversion error.\n");
+		exit(1);
+	}
+
+	str[offset] = '\0';
+	return str;
+}
+
 /** Display survival help message. */
 void os_input_disp_help(void)
Index: uspace/app/sbi/src/os/os.h
===================================================================
--- uspace/app/sbi/src/os/os.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/os/os.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -36,4 +36,5 @@
 size_t os_str_length(const char *str);
 int os_str_get_char(const char *str, int index, int *out_char);
+char *os_chr_to_astr(wchar_t chr);
 void os_input_disp_help(void);
 int os_input_line(char **ptr);
Index: uspace/app/sbi/src/os/posix.c
===================================================================
--- uspace/app/sbi/src/os/posix.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/app/sbi/src/os/posix.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -159,4 +159,25 @@
 }
 
+/** Convert character to new string.
+ *
+ * @param chr		Character
+ * @return		Newly allocated string.
+ */
+char *os_chr_to_astr(wchar_t chr)
+{
+	char *str;
+
+	str = malloc(2);
+	if (str == NULL) {
+		printf("Memory allocation error.\n");
+		exit(1);
+	}
+
+	str[0] = (char) chr;
+	str[1] = '\0';
+
+	return str;
+}
+
 #define OS_INPUT_BUFFER_SIZE 256
 static char os_input_buffer[OS_INPUT_BUFFER_SIZE];
